import os 
import zypp

class CommitReceiver:
  def removal_start(self, resolvable):
    print "Starting to remove ", resolvable.name()

  def removal_progress(self, resolvable, percentage):
    print "Remove of ", resolvable.name(), " at ", percentage, "%"

  def removal_finish(self, resolvable, error, reason):
    print "Remove finished "

Z = zypp.ZYppFactory_instance().getZYpp()
Z.initializeTarget( zypp.Pathname("/") )
Z.target().load();

commit_callbacks_emitter = zypp.CommitCallbacksEmitter()
commit_callbacks = zypp.CommitCallbacks()
commit_receiver = CommitReceiver()
commit_callbacks.connect(commit_receiver)

for item in Z.pool():
    if item.resolvable().name() == "gedit":
        print "Emitting removal of ", item.resolvable().name()
        item.status().setToBeUninstalled(zypp.ResStatus.USER)
        resolvable = item.resolvable()
        #commit_callbacks_emitter.remove_start(resolvable)
        if not Z.resolver().resolvePool():
            print "Problem count: %d" % Z.resolver().problems().size()
        policy = zypp.ZYppCommitPolicy()
        policy.downloadMode(zypp.DownloadInAdvance)
        policy.dryRun( False )
        policy.syncPoolAfterCommit( False )

        result = Z.commit( policy )
        print result
        break

commit_callbacks.disconnect()
print "disconnected"
